<?php

/* No direct access */
defined('_OW_') or die('Restricted access');

class BILLINGFREEKASSA_CLASS_FreekassaAdapter implements OW_BillingAdapter
{
    const GATEWAY_KEY = 'billingfreekassa';

    /**
     * @var BOL_BillingService
     */
    private $billingService;

    public function __construct()
    {
        $this->billingService = BOL_BillingService::getInstance();
    }

    public function prepareSale( BOL_BillingSale $sale )
    {
        // ... gateway custom manipulations

        return $this->billingService->saveSale($sale);
    }

    public function verifySale( BOL_BillingSale $sale )
    {
        // ... gateway custom manipulations

        return $this->billingService->saveSale($sale);
    }

    /**
     * (non-PHPdoc)
     * @see ow_core/OW_BillingAdapter#getFields($params)
     */
    public function getFields( $params = null )
    {
        $router = OW::getRouter();

        return array(
            'fkSecretWord_1' => $this->billingService->getGatewayConfigValue(self::GATEWAY_KEY, 'fkSecretWord_1'),
            'fkSecretWord_2' => $this->billingService->getGatewayConfigValue(self::GATEWAY_KEY, 'fkSecretWord_2'),
            'fkMerchantId' => $this->billingService->getGatewayConfigValue(self::GATEWAY_KEY, 'fkMerchantId'),
			'fkCurrency' => $this->billingService->getGatewayConfigValue(self::GATEWAY_KEY, 'fkCurrency'),
			'tabNum' => $this->billingService->getGatewayConfigValue(self::GATEWAY_KEY, 'tabNum'),
            'formActionUrl' => $this->getOrderFormActionUrl()
        );
    }

    /**
     * (non-PHPdoc)
     * @see ow_core/OW_BillingAdapter#getOrderFormUrl()
     */
    public function getOrderFormUrl()
    {
        return OW::getRouter()->urlForRoute('billing_freekassa_order_form');
    }

    /**
     * (non-PHPdoc)
     * @see ow_core/OW_BillingAdapter#getLogoUrl()
     */
    public function getLogoUrl()
    {
        $plugin = OW::getPluginManager()->getPlugin('billingfreekassa');

        return $plugin->getStaticUrl() . 'img/freekassa_logo.png';
    }

    /**
     * Returns freekassa gateway script url (sandbox or live)
     * 
     * @return string
     */
    private function getOrderFormActionUrl()
    {
        return 'http://www.free-kassa.ru/merchant/cash.php';
    }

    /**
     * Posts data back to freekassa for order verification
     *  
     * @param array $post
     * @return boolean
     */
    public function isVerified($request)
    {
        $md5secret = md5($this->billingService->getGatewayConfigValue(self::GATEWAY_KEY, 'fkMerchantId').':'.$request['AMOUNT'].':'.$this->billingService->getGatewayConfigValue(self::GATEWAY_KEY, 'fkSecretWord_2').':'.$request['MERCHANT_ORDER_ID']); 
        return $md5secret == $request['SIGN'];
    }
}
