<?php

class BILLINGFREEKASSA_CTRL_Order extends OW_ActionController
{

    public function form()
    {
        $billingService = BOL_BillingService::getInstance();
        $adapter = new BILLINGFREEKASSA_CLASS_FreekassaAdapter();
        $lang = OW::getLanguage();

        $sale = $billingService->getSessionSale();
        
        if ( !$sale )
        {
            $url = $billingService->getSessionBackUrl();
            if ( $url != null )
            {
                OW::getFeedback()->warning($lang->text('base', 'billing_order_canceled'));
                $billingService->unsetSessionBackUrl();
                $this->redirect($url);
            }
            else 
            {
                $this->redirect($billingService->getOrderFailedPageUrl());
            }
        }

        $formId = uniqid('order_form-');
        $this->assign('formId', $formId);

        $js = '$("#' . $formId . '").submit()';
        OW::getDocument()->addOnloadScript($js);

        $fields = $adapter->getFields();
        
        $fields['sign'] = md5($fields['fkMerchantId'].":".$sale->price.":".$fields['fkSecretWord_1'].":".$sale->id);
        $this->assign('fields', $fields);
             
        $this->assign('email', OW::getUser()->getEmail()); //
            
        if ( $billingService->prepareSale($adapter, $sale) )
        {
            $sale->totalAmount = floatval($sale->totalAmount);
            $this->assign('sale', $sale);


            $masterPageFileDir = OW::getThemeManager()->getMasterPageTemplate('blank');
            OW::getDocument()->getMasterPage()->setTemplate($masterPageFileDir);

            $billingService->unsetSessionSale();
        }
        else
        {
            $productAdapter = $billingService->getProductAdapter($sale->entityKey);

            if ( $productAdapter )
            {
                $productUrl = $productAdapter->getProductOrderUrl();
            }
            
            OW::getFeedback()->warning($lang->text('base', 'billing_order_init_failed'));
            $url = isset($productUrl) ? $productUrl : $billingService->getOrderFailedPageUrl();
            
            $this->redirect($url);
        }
    }

    public function notify()
    {
        if ( empty($_REQUEST['MERCHANT_ORDER_ID']) ) {
            exit;
        }

        $hash = trim($_REQUEST['us_hash']);

        $transactionId = trim($_REQUEST['intid']);
        $status = 'COMPLETED';

        $billingService = BOL_BillingService::getInstance();
        $adapter = new BILLINGFREEKASSA_CLASS_FreekassaAdapter();

        if ( $adapter->isVerified($_REQUEST) )
        {
            $sale = $billingService->getSaleByHash($hash);

            if ( !$sale || !strlen($transactionId) )
            {
                exit;
            }

            if ( $status == 'COMPLETED' )
            {
                if ( !$billingService->saleDelivered($transactionId, $sale->gatewayId) )
                {
                    $sale->transactionUid = $transactionId;

                    if ( $billingService->verifySale($adapter, $sale) )
                    {
                        $sale = $billingService->getSaleById($sale->id);
                                
                        $productAdapter = $billingService->getProductAdapter($sale->entityKey);

                        if ( $productAdapter )
                        {
                            $billingService->deliverSale($productAdapter, $sale);
							die('OK');
                        }
                    }
					die;
                } else {
					die('OK');
			    }
            }
			die;
        }
        else
        {
            exit;
        }
    }

    public function completed()
    {
        $hash = $_REQUEST['us_hash'];

        $this->redirect(BOL_BillingService::getInstance()->getOrderCompletedPageUrl($hash));
    }
    
    public function canceled()
    {
        $this->redirect(BOL_BillingService::getInstance()->getOrderCancelledPageUrl());
    }
}
