<?php

/**
 * Copyright (c) 2011, SocEngine SoftWare
 * All rights reserved.

 * ATTENTION: This commercial software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ or http://www.oxwall.su/
 * and is licensed under Oxwall Store Commercial License.
 * Full text of this license can be found at http://www.oxwall.org/store/oscl
 */
OW::getRouter()->addRoute(new OW_Route('billing_freekassa_order_form', 'billing-freekassa/order', 'BILLINGFREEKASSA_CTRL_Order', 'form'));
OW::getRouter()->addRoute(new OW_Route('billing_freekassa_notify', 'billing-freekassa/order/notify', 'BILLINGFREEKASSA_CTRL_Order', 'notify'));
OW::getRouter()->addRoute(new OW_Route('billing_freekassa_completed', 'billing-freekassa/order/completed/', 'BILLINGFREEKASSA_CTRL_Order', 'completed'));
OW::getRouter()->addRoute(new OW_Route('billing_freekassa_canceled', 'billing-freekassa/order/canceled/', 'BILLINGFREEKASSA_CTRL_Order', 'canceled'));
OW::getRouter()->addRoute(new OW_Route('billing_freekassa_admin', 'admin/billing-freekassa', 'BILLINGFREEKASSA_CTRL_Admin', 'index'));

function freekassa_add_admin_notification( BASE_CLASS_EventCollector $coll )
{
    $billingService = BOL_BillingService::getInstance();

    if ( !mb_strlen($billingService->getGatewayConfigValue(BILLINGFREEKASSA_CLASS_FreekassaAdapter::GATEWAY_KEY, 'fkSecretWord_1')) && 
        !mb_strlen($billingService->getGatewayConfigValue(BILLINGFREEKASSA_CLASS_FreekassaAdapter::GATEWAY_KEY, 'fkSecretWord_2')) && 
        !mb_strlen($billingService->getGatewayConfigValue(BILLINGFREEKASSA_CLASS_FreekassaAdapter::GATEWAY_KEY, 'fkMerchantId')))
    {
        $coll->add(
            OW::getLanguage()->text(
                'billingfreekassa', 
                'plugin_configuration_notice', 
                array('url' => OW::getRouter()->urlForRoute('billing_freekassa_admin'))
            )
        );
    }
}

OW::getEventManager()->bind('admin.add_admin_notification', 'freekassa_add_admin_notification');